hdu 3183 A Magic Lamp(RMQ)

32 篇文章 0 订阅
5 篇文章 0 订阅
Kiki likes traveling. One day she finds a magic lamp, unfortunately the genie in the lamp is not so kind. Kiki must answer a question, and then the genie will realize one of her dreams.
The question is: give you an integer, you are allowed to delete exactly m digits. The left digits will form a new integer. You should make it minimum.
You are not allowed to change the order of the digits. Now can you help Kiki to realize her dream?

Input
There are several test cases.
Each test case will contain an integer you are given (which may at most contains 1000 digits.) and the integer m (if the integer contains n digits, m will not bigger then n). The given integer will not contain leading zero.
Output
For each case, output the minimum result you can get in one line.
If the result contains leading zero, ignore it.
Sample Input
178543 4 
1000001 1
100001 2
12345 2
54321 2
Sample Output
13
1
0
123
321



题意:给你一串数字(不超过1000位),问在原有的顺序不变的情况下,去掉m位后,形成的最小的数是多少。


这道题可以用贪心来做,也可以用RMQ来做。使用RMQ,设原数字长为n,那么除去m个数字后还剩n-m个数字。
(1)因为有n-m个数字,那么在1到m+1位置中最小的那个数字必是结果中的第一个数字,记录其位置为pos
(2)然后从这个位置的下个位置pos+1开始到m+2位置的数字中最小的那个数字必定是结果中第二个数字,以此类推下去向后找。
(3)为了保证数字最小,所以要保证高位最小,还要保证数字长度满足条件


#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<cstdlib>
#include<string>

using namespace std;
int a[1100],dp[1100][20],m,len,ans[1100];
void RMQ()
{
    for(int i=1; i<=len; i++)
        dp[i][0]=a[i];
    for(int j=1; (1<<j)<=len; j++)
        for(int i=1; i+(1<<j)-1<=len; i++)
            dp[i][j]=min(dp[i][j-1],dp[i+(1<<(j-1))][j-1]);
}

int Find(int l,int r)
{
    int k=(int)(log10(r-l+1)/log10(2.0));
    return min(dp[l][k],dp[r-(1<<k)+1][k]);
}

int main()
{
    string str;
    while(cin>>str>>m)
    {
        len=str.length();
        for(int i=0; i<len; i++)
            a[i+1]=str[i]-'0';
        RMQ();
        int l=1,r=m+1,k=0;
        for(int i=1; i<=len-m; i++)
        {
            int num=Find(l,r);
            ans[k++]=num;
            for(int j=l; j<=r; j++)
            {
                if(num==a[j])
                {
                    l=j+1;
                    break;
                }
            }
            r=r+1;
        }
        int i=0;
        while(ans[i]==0&&i<k)
            i++;
        if(i==k)
            printf("0");
        else
        {
            while(i<k)
                printf("%d",ans[i]),i++;
        }
        printf("\n");
    }
    return 0;
}


上面查找最小值的过程用了双重for循环来做的,数据大的话就可能会超时,因为是要求下标,我们可以改一下RMQ,使得求出的RMQ就是数组的下标。


#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<cstdlib>
#include<string>

using namespace std;
int a[1100],dp[1100][20],m,len,ans[1100];

int Min(int i,int j)
{
    if(a[i]<=a[j])
        return i;
    return j;
}

void RMQ()
{
    for(int i=1; i<=len; i++)
        dp[i][0]=i;
    for(int j=1; (1<<j)<=len; j++)
        for(int i=1; i+(1<<j)-1<=len; i++)
            dp[i][j]=Min(dp[i][j-1],dp[i+(1<<(j-1))][j-1]);//这里求最小值的时候可以定义一个函数,返回下标
}

int Find(int l,int r)
{
    int k=(int)(log10(r-l+1)/log10(2.0));
    return Min(dp[l][k],dp[r-(1<<k)+1][k]);
}

int main()
{
    string str;
    while(cin>>str>>m)
    {
        len=str.length();
        for(int i=0; i<len; i++)
            a[i+1]=str[i]-'0';
        RMQ();
        int t=len-m;
        int l=1,r=m+1,k=0;
        while(t--)//这样一个循环就好了
        {
            l=Find(l,r)+1;
            ans[k++]=a[l-1];
            r=r+1;
        }
        int i=0;
        while(ans[i]==0&&i<k)
            i++;
        if(i==k)
            printf("0");
        else
        {
            while(i<k)
                printf("%d",ans[i]),i++;
        }
        printf("\n");
    }
    return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值